searchNodes=[{"doc":"This is a non-official third-party client for Segment . Since version 2.0 it supports batch delivery of events and retries for the API. Installation Add segment to your list of dependencies in mix.exs . def deps do [ { :segment , &quot;~&gt; 0.2.6&quot; } ] end Usage Start the Segment agent with your write_key from Segment for a HTTP API Server Source Segment . start_link ( &quot;YOUR_WRITE_KEY&quot; ) There are then two ways to call the different methods on the API. A basic way through Segment.Analytics functions with either the full event Struct or some helper methods (also allowing Context and Integrations to be set manually). This way will use the defined GenServer implementation such as Segment.Analytics.Batcher which will queue and batch events to Segment. The other way is to drop down lower and use Segment.Http send and batch directly. This will require first creating a client with Segment.Http.client/1 / Segment.Http.client/2 Track Segment.Analytics . track ( user_id , event , %{ property1 : &quot;&quot; , property2 : &quot;&quot; } ) or the full way using a struct with all the possible options for the track call % Segment.Analytics.Track { userId : &quot;sdsds&quot; , event : &quot;eventname&quot; , properties : %{ property1 : &quot;&quot; , property2 : &quot;&quot; } } |&gt; Segment.Analytics . track Identify Segment.Analytics . identify ( user_id , %{ trait1 : &quot;&quot; , trait2 : &quot;&quot; } ) Or the full way using a struct with all the possible options for the identify call. % Segment.Analytics.Identify { userId : &quot;sdsds&quot; , traits : %{ trait1 : &quot;&quot; , trait2 : &quot;&quot; } } |&gt; Segment.Analytics . identify Screen Segment.Analytics . screen ( user_id , name ) Or the full way using a struct with all the possible options for the screen call. % Segment.Analytics.Screen { userId : &quot;sdsds&quot; , name : &quot;dssd&quot; } |&gt; Segment.Analytics . screen Alias Segment.Analytics . alias ( user_id , previous_id ) Or the full way using a struct with all the possible options for the alias call. % Segment.Analytics.Alias { userId : &quot;sdsds&quot; , previousId : &quot;dssd&quot; } |&gt; Segment.Analytics . alias Group Segment.Analytics . group ( user_id , group_id ) Or the full way using a struct with all the possible options for the group call. % Segment.Analytics.Group { userId : &quot;sdsds&quot; , groupId : &quot;dssd&quot; } |&gt; Segment.Analytics . group Page Segment.Analytics . page ( user_id , name ) Or the full way using a struct with all the possible options for the page call. % Segment.Analytics.Page { userId : &quot;sdsds&quot; , name : &quot;dssd&quot; } |&gt; Segment.Analytics . page Using the Segment Context If you want to set the Context manually you should create a Segment.Analytics.Context struct with Segment.Analytics.Context.new/1 context = Segment.Analytics.Context . new ( %{ active : false } ) Segment.Analytics . track ( user_id , event , %{ property1 : &quot;&quot; , property2 : &quot;&quot; } , context ) Configuration The library has a number of configuration options you can use to overwrite default values and behaviours config :segment, :sender_impl Allows selection of a sender implementation. At the moment this defaults to Segment.Analytics.Batcher which will send all events in batch. Change this value to Segment.Analytics.Sender to have all messages sent immediately (asynchronously) config :segment, :max_batch_size The maximum batch size of messages that will be sent to Segment at one time. Default value is 100. config :segment, :batch_every_ms The time (in ms) between every batch request. Default value is 2000 (2 seconds) config :segment, :retry_attempts The number of times to retry sending against the segment API. Default value is 3 config :segment, :retry_expiry The maximum time (in ms) spent retrying. Default value is 10000 (10 seconds) config :segment, :retry_start The time (in ms) to start the first retry. Default value is 100 config :segment, :send_to_http If set to false , the library will override the Tesla Adapter implementation to only log segment calls to debug but not make any actual API calls. This can be useful if you want to switch off Segment for test or dev. Default value is true config :segment, :tesla, :adapter This config option allows for overriding the HTTP Adapter for Tesla (which the library defaults to Hackney).This can be useful if you prefer something else, or want to mock the adapter for testing. config :segment, api_url: &quot;https://self-hosted-segment-api.com/v1/&quot; The Segment-compatible API endpoint that will receive your events. Defaults to https://api.segment.io/v1/ . This setting is only useful if you are using Segment's EU instance or a Segment-compatible alternative API like Rudderstack . Usage in Phoenix This is how I add to a Phoenix project (may not be your preferred way) Add the following to deps section of your mix.exs: {:segment, &quot;~&gt; 0.2.0&quot;} and then mix deps.get Add a config variable for your write_key (you may want to make this load from ENV) ie. config :segment , write_key : &quot;2iFFnRsCfi&quot; Start the Segment GenServer in the supervised children list. In application.ex add to the children list: { Segment , Application . get_env ( :segment , :write_key ) } Running tests There are not many tests at the moment. if you want to run live tests on your account you need to change the config in test.exs to config :segment, :send_to_http, true and then provide your key as an environment variable. SEGMENT_KEY = yourkey mix test Telemetry This package wraps its Segment event sending in :telemetry.span/3 . You can attach to: [:segment, :send, :start] [:segment, :send, :stop] [:segment, :send, :exception] [:segment, :batch, :start] [:segment, :batch, :stop] [:segment, :batch, :exception] The measurements will include, in Erlang's :native time unit (likely :nanosecond ): system_time with :start events duration with :stop and :exception events The metadata will include: the original event or events with all :send and :batch events respectively our status ( :ok | :error ) and Tesla's result with all :stop events error matching result when it isn't {:ok, env} kind , reason , and stacktrace with :exception events","ref":"Segment.html","title":"Segment","type":"module"},{"doc":"","ref":"Segment.html#child_spec/1","title":"Segment.child_spec/1","type":"function"},{"doc":"Start the configured GenServer for handling Segment events with the Segment HTTP Source API Write Key By default if nothing is configured it will start Segment.Analytics.Batcher","ref":"Segment.html#start_link/1","title":"Segment.start_link/1","type":"function"},{"doc":"Start the configured GenServer for handling Segment events with the Segment HTTP Source API Write Key and a custom Tesla Adapter. By default if nothing is configured it will start Segment.Analytics.Batcher","ref":"Segment.html#start_link/2","title":"Segment.start_link/2","type":"function"},{"doc":"","ref":"Segment.html#t:segment_event/0","title":"Segment.segment_event/0","type":"type"},{"doc":"The Segment.Analytics module is the easiest way to send Segment events and provides convenience methods for track , identify, screen , alias , group , and page calls The functions will then delegate the call to the configured service implementation which can be changed with: config :segment , sender_impl : Segment.Analytics.Batcher , By default (if no configuration is given) it will use Segment.Analytics.Batcher to send events in a batch periodically","ref":"Segment.Analytics.html","title":"Segment.Analytics","type":"module"},{"doc":"alias is how you associate one identity with another with properties defined in the Segment.Analytics.Alias struct See https://segment.com/docs/spec/alias/","ref":"Segment.Analytics.html#alias/1","title":"Segment.Analytics.alias/1","type":"function"},{"doc":"alias is how you associate one identity with another. alias/3 takes a user_id and a previous_id to map from. It also takes an optional Segment.Analytics.Context struct. See https://segment.com/docs/spec/alias/","ref":"Segment.Analytics.html#alias/3","title":"Segment.Analytics.alias/3","type":"function"},{"doc":"","ref":"Segment.Analytics.html#call/1","title":"Segment.Analytics.call/1","type":"function"},{"doc":"The group call is how you associate an individual user with a group with the properties in the defined in the Segment.Analytics.Group struct See https://segment.com/docs/spec/group/","ref":"Segment.Analytics.html#group/1","title":"Segment.Analytics.group/1","type":"function"},{"doc":"The group call is how you associate an individual user with a group. group/4 takes a user_id and a group_id to associate it with. It also takes optional traits of the group and an optional Segment.Analytics.Context struct. See https://segment.com/docs/spec/group/","ref":"Segment.Analytics.html#group/4","title":"Segment.Analytics.group/4","type":"function"},{"doc":"identify lets you tie a user to their actions and record traits about them as defined in the Segment.Analytics.Identify struct See https://segment.com/docs/spec/identify/","ref":"Segment.Analytics.html#identify/1","title":"Segment.Analytics.identify/1","type":"function"},{"doc":"identify lets you tie a user to their actions and record traits about them. identify/3 takes a user_id , optional additional traits and an optional Segment.Analytics.Context struct. See https://segment.com/docs/spec/identify/","ref":"Segment.Analytics.html#identify/3","title":"Segment.Analytics.identify/3","type":"function"},{"doc":"The page call lets you record whenever a user sees a page of your website with the properties defined in the Segment.Analytics.Page struct See https://segment.com/docs/spec/page/","ref":"Segment.Analytics.html#page/1","title":"Segment.Analytics.page/1","type":"function"},{"doc":"The page call lets you record whenever a user sees a page of your website. page/4 takes a user_id and an optional page_name , optional properties and an optional Segment.Analytics.Context struct. See https://segment.com/docs/spec/page/","ref":"Segment.Analytics.html#page/4","title":"Segment.Analytics.page/4","type":"function"},{"doc":"screen let you record whenever a user sees a screen of your mobile app with properties defined in the Segment.Analytics.Screen struct See https://segment.com/docs/spec/screen/","ref":"Segment.Analytics.html#screen/1","title":"Segment.Analytics.screen/1","type":"function"},{"doc":"screen let you record whenever a user sees a screen of your mobile app. screen/4 takes a user_id , an optional screen_name , optional properties and an optional Segment.Analytics.Context struct. See https://segment.com/docs/spec/screen/","ref":"Segment.Analytics.html#screen/4","title":"Segment.Analytics.screen/4","type":"function"},{"doc":"Make a call to Segment with an event. Should be of type Track, Identify, Screen, Alias, Group or Page","ref":"Segment.Analytics.html#send/1","title":"Segment.Analytics.send/1","type":"function"},{"doc":"track lets you record the actions your users perform. Every action triggers what Segment call an “event”, which can also have associated properties as defined in the Segment.Analytics.Track struct See https://segment.com/docs/spec/track/","ref":"Segment.Analytics.html#track/1","title":"Segment.Analytics.track/1","type":"function"},{"doc":"track lets you record the actions your users perform. Every action triggers what Segment call an “event”, which can also have associated properties. track/4 takes a user_id , an event_name , optional additional properties and an optional Segment.Analytics.Context struct. See https://segment.com/docs/spec/track/","ref":"Segment.Analytics.html#track/4","title":"Segment.Analytics.track/4","type":"function"},{"doc":"","ref":"Segment.Analytics.html#t:segment_id/0","title":"Segment.Analytics.segment_id/0","type":"type"},{"doc":"The Segment.Analytics.Batcher module is the default service implementation for the library which uses the Segment Batch HTTP API to put events in a FIFO queue and send on a regular basis. The Segment.Analytics.Batcher can be configured with config :segment , max_batch_size : 100 , batch_every_ms : 5000 config :segment, :max_batch_size The maximum batch size of messages that will be sent to Segment at one time. Default value is 100. config :segment, :batch_every_ms The time (in ms) between every batch request. Default value is 2000 (2 seconds) The Segment Batch API does have limits on the batch size &quot;There is a maximum of 500KB per batch request and 32KB per call.&quot;. While the library doesn't check the size of the batch, if this becomes a problem you can change max_batch_size to a lower number and probably want to change batch_every_ms to run more frequently. The Segment API asks you to limit calls to under 50 a second, so even if you have no other Segment calls going on, don't go under 20ms!","ref":"Segment.Analytics.Batcher.html","title":"Segment.Analytics.Batcher","type":"module"},{"doc":"Make a call to Segment with an event. Should be of type Track, Identify, Screen, Alias, Group or Page . This event will be queued and sent later in a batch.","ref":"Segment.Analytics.Batcher.html#call/1","title":"Segment.Analytics.Batcher.call/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Segment.Analytics.Batcher.html#child_spec/1","title":"Segment.Analytics.Batcher.child_spec/1","type":"function"},{"doc":"Force the batcher to flush the queue and send all the events as a big batch (warning could exceed batch size)","ref":"Segment.Analytics.Batcher.html#flush/0","title":"Segment.Analytics.Batcher.flush/0","type":"function"},{"doc":"Start the Segment.Analytics.Batcher GenServer with an Segment HTTP Source API Write Key","ref":"Segment.Analytics.Batcher.html#start_link/1","title":"Segment.Analytics.Batcher.start_link/1","type":"function"},{"doc":"Start the Segment.Analytics.Batcher GenServer with an Segment HTTP Source API Write Key and a Tesla Adapter. This is mainly used for testing purposes to override the Adapter with a Mock.","ref":"Segment.Analytics.Batcher.html#start_link/2","title":"Segment.Analytics.Batcher.start_link/2","type":"function"},{"doc":"The Segment.Analytics.Sender service implementation is an alternative to the default Batcher to send every event as it is called. The HTTP call is made with an async Task to not block the GenServer. This will not guarantee ordering. The Segment.Analytics.Batcher should be preferred in production but this module will emulate the implementation of the original library if you need that or need events to be as real-time as possible.","ref":"Segment.Analytics.Sender.html","title":"Segment.Analytics.Sender","type":"module"},{"doc":"Make a call to Segment with an event. Should be of type Track, Identify, Screen, Alias, Group or Page . This event will be sent immediately and asynchronously","ref":"Segment.Analytics.Sender.html#call/1","title":"Segment.Analytics.Sender.call/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Segment.Analytics.Sender.html#child_spec/1","title":"Segment.Analytics.Sender.child_spec/1","type":"function"},{"doc":"Start the Segment.Analytics.Sender GenServer with an Segment HTTP Source API Write Key","ref":"Segment.Analytics.Sender.html#start_link/1","title":"Segment.Analytics.Sender.start_link/1","type":"function"},{"doc":"Start the Segment.Analytics.Sender GenServer with an Segment HTTP Source API Write Key and a Tesla Adapter. This is mainly used for testing purposes to override the Adapter with a Mock.","ref":"Segment.Analytics.Sender.html#start_link/2","title":"Segment.Analytics.Sender.start_link/2","type":"function"},{"doc":"Segment.Http is the underlying implementation for making calls to the Segment HTTP API. The send/2 and batch/4 methods can be used for sending events or batches of events to the API. The sending can be configured with config :segment , send_to_http : true retry_attempts : 3 , retry_expiry : 10_000 , retry_start : 100 config :segment, :retry_attempts The number of times to retry sending against the segment API. Default value is 3 config :segment, :retry_expiry The maximum time (in ms) spent retrying. Default value is 10000 (10 seconds) config :segment, :retry_start The time (in ms) to start the first retry. Default value is 100 config :segment, :send_to_http If set to false , the library will override the Tesla Adapter implementation to only log segment calls to debug but not make any actual API calls. This can be useful if you want to switch off Segment for test or dev. Default value is true The retry uses a linear back-off strategy when retrying the Segment API. Additionally a different Tesla Adapter can be used if you want to use something other than Hackney. config :segment, :tesla, :adapter This config option allows for overriding the HTTP Adapter for Tesla (which the library defaults to Hackney).This can be useful if you prefer something else, or want to mock the adapter for testing.","ref":"Segment.Http.html","title":"Segment.Http","type":"module"},{"doc":"Send a list of Segment events as a batch. The batch function takes optional arguments for context and integrations which can be applied to the entire batch of events. See Segment's docs","ref":"Segment.Http.html#batch/4","title":"Segment.Http.batch/4","type":"function"},{"doc":"Create a Tesla client with the Segment Source Write API Key","ref":"Segment.Http.html#client/1","title":"Segment.Http.client/1","type":"function"},{"doc":"Create a Tesla client with the Segment Source Write API Key and the given Tesla adapter","ref":"Segment.Http.html#client/2","title":"Segment.Http.client/2","type":"function"},{"doc":"Send a list of Segment events as a batch","ref":"Segment.Http.html#send/2","title":"Segment.Http.send/2","type":"function"},{"doc":"","ref":"Segment.Http.html#t:adapter/0","title":"Segment.Http.adapter/0","type":"type"},{"doc":"","ref":"Segment.Http.html#t:client/0","title":"Segment.Http.client/0","type":"type"},{"doc":"The Segment.Http.Stub is used to replace the Tesla adapter with something that logs and returns success. It is used if send_to_http has been set to false","ref":"Segment.Http.Stub.html","title":"Segment.Http.Stub","type":"module"},{"doc":"","ref":"Segment.Http.Stub.html#call/2","title":"Segment.Http.Stub.call/2","type":"function"}]